org.cpsolver.coursett.heuristics

## Class NeighbourSelectionWithSuggestions

- java.lang.Object
- - org.cpsolver.ifs.heuristics.StandardNeighbourSelection<Lecture,Placement>
  - - org.cpsolver.coursett.heuristics.NeighbourSelectionWithSuggestions

- All Implemented Interfaces:
    NeighbourSelection<Lecture,Placement>

      public class NeighbourSelectionWithSuggestions
      extends StandardNeighbourSelection<Lecture,Placement>

  Neighbour selection which does the standard time neighbour selection most of the time, however, the very best neighbour is selected time to time (using backtracking based search).
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  See Also:
    `StandardNeighbourSelection`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `NeighbourSelectionWithSuggestions.NeighbourSelectionWithSuggestionsContext`
    `class` | `NeighbourSelectionWithSuggestions.SuggestionNeighbour`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `sLogger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NeighbourSelectionWithSuggestions(DataProperties properties)`
    `NeighbourSelectionWithSuggestions(Solver<Lecture,Placement> solver)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Lecture,Placement> solver)` Initialization -- methods `VariableSelection.init(Solver)` and `ValueSelection.init(Solver)` are called.
    `Neighbour<Lecture,Placement>` | `selectNeighbour(Solution<Lecture,Placement> solution)` Select neighbour.
    `Neighbour<Lecture,Placement>` | `selectNeighbourWithSuggestions(Solution<Lecture,Placement> solution, Lecture lecture, int depth)`

    - ### Methods inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `getValueSelection, getVariableSelection, selectValue, selectVariable, setValueSelection, setVariableSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NeighbourSelectionWithSuggestions

          public NeighbourSelectionWithSuggestions(DataProperties properties)
                                            throws Exception

      Throws:
        `Exception`

    - #### NeighbourSelectionWithSuggestions

          public NeighbourSelectionWithSuggestions(Solver<Lecture,Placement> solver)
                                            throws Exception

      Throws:
        `Exception`

  - ### Method Detail

    - #### init

          public void init(Solver<Lecture,Placement> solver)

      Description copied from class: `StandardNeighbourSelection`
      Initialization -- methods `VariableSelection.init(Solver)` and `ValueSelection.init(Solver)` are called.
      Specified by:
        `init` in interface `NeighbourSelection<Lecture,Placement>`
      Overrides:
        `init` in class `StandardNeighbourSelection<Lecture,Placement>`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Lecture,Placement> selectNeighbour(Solution<Lecture,Placement> solution)

      Description copied from class: `StandardNeighbourSelection`
      Select neighbour. A value is selected to the selected variable.
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Lecture,Placement>`
      Overrides:
        `selectNeighbour` in class `StandardNeighbourSelection<Lecture,Placement>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment

    - #### selectNeighbourWithSuggestions

          public Neighbour<Lecture,Placement> selectNeighbourWithSuggestions(Solution<Lecture,Placement> solution,
                                                                             Lecture lecture,
                                                                             int depth)